codeforces 651E E. Table Compression(贪心+并查集)

题目链接:

E. Table Compression

time limit per test
4 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Little Petya is now fond of data compression algorithms. He has already studied gz, bz, zip algorithms and many others. Inspired by the new knowledge, Petya is now developing the new compression algorithm which he wants to name dis.

Petya decided to compress tables. He is given a table a consisting of n rows and m columns that is filled with positive integers. He wants to build the table a' consisting of positive integers such that the relative order of the elements in each row and each column remains the same. That is, if in some row i of the initial table ai, j < ai, k, then in the resulting table a'i, j < a'i, k, and if ai, j = ai, k then a'i, j = a'i, k. Similarly, if in some column j of the initial table ai, j < ap, j then in compressed table a'i, j < a'p, j and if ai, j = ap, j then a'i, j = a'p, j.

Because large values require more space to store them, the maximum value in a' should be as small as possible.

Petya is good in theory, however, he needs your help to implement the algorithm.

Input

The first line of the input contains two integers n and m (, the number of rows and the number of columns of the table respectively.

Each of the following n rows contain m integers ai, j (1 ≤ ai, j ≤ 109) that are the values in the table.

Output

Output the compressed table in form of n lines each containing m integers.

If there exist several answers such that the maximum number in the compressed table is minimum possible, you are allowed to output any of them.

Examples
input
2 2
1 2
3 4
output
1 2
2 3
input
4 3
20 10 30
50 40 30
50 60 70
90 80 70
output
2 1 3
5 4 3
5 6 7
9 8 7

题意:

给一个n*m的矩阵,要你在不该变任意一行或一列中两个数的大小关系使得这个矩阵的最大值最小;

思路:

假设这些数全部都不相等,那么我们可以排序后再按从小到大的顺序插入到原来的位置上,插入的是这个位置所在行和列的最大数+1,而现在其中有些数相同,
思考后可知,相等的数不在同行或同列时互相没有影响,跟上述插入方式一样,但是如果在同行或者同列,那么位置插入的数的大小应该相同,且是这些位置的所在行和列的最大值+1;
所以我们把在同行或者同列的相同的数放在一个集合里面,改变一个的时候全部改变,这就可以用并查集了;
具体的实现看代码;

AC代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <bits/stdc++.h>
#include <stack>
#include <map>
 
using namespace std;
 
#define For(i,j,n) for(int i=j;i<=n;i++)
#define mst(ss,b) memset(ss,b,sizeof(ss));
 
typedef  long long LL;
 
template<class T> void read(T&num) {
    char CH; bool F=false;
    for(CH=getchar();CH<'0'||CH>'9';F= CH=='-',CH=getchar());
    for(num=0;CH>='0'&&CH<='9';num=num*10+CH-'0',CH=getchar());
    F && (num=-num);
}
int stk[70], tp;
template<class T> inline void print(T p) {
    if(!p) { puts("0"); return; }
    while(p) stk[++ tp] = p%10, p/=10;
    while(tp) putchar(stk[tp--] + '0');
    putchar('\n');
}
 
const LL mod=1e9+7;
const double PI=acos(-1.0);
const int inf=1e9;
const int N=1e6+120;
const int maxn=210;
const double eps=1e-12;

int n,m,a[N],p[N],l[N],r[N],vis[N],ans[N];
vector<int>ve[N];
struct node
{
    int a,id,i,j;
}po[N];
int cmp1(node x,node y)
{
    if(x.a==y.a)return x.i<y.i;
    return x.a<y.a;
}
int cmp2(node x,node y)
{
    if(x.a==y.a)return x.j<y.j;
    return x.a<y.a;
}
int findset(int x)
{
    if(p[x]==x)return x;
    return p[x]=findset(p[x]);
}
int same(int x,int y)
{
    int fx=findset(x),fy=findset(y);
    if(fx<fy)p[fy]=fx;
    else if(fx>fy)p[fx]=fy;
}

int main()
{
    int cnt=0;
    read(n);read(m);
    For(i,0,n*m)p[i]=i;
    For(i,1,n)
    {
        For(j,1,m)
        {
            cnt++;
            po[cnt].id=cnt;
            po[cnt].i=i;po[cnt].j=j;
            read(po[cnt].a);
        }
    }
    sort(po+1,po+cnt+1,cmp2);//两次排序把在同行和同列的相同的数合并
    For(i,2,cnt)
    {
        if(po[i].a==po[i-1].a&&po[i].j==po[i-1].j)same(po[i].id,po[i-1].id);
    }
    sort(po+1,po+cnt+1,cmp1);
    For(i,2,cnt)
    {
        if(po[i].a==po[i-1].a&&po[i].i==po[i-1].i)same(po[i].id,po[i-1].id);
    }
    For(i,1,cnt)//可以由root找到这个集合所有数所在的位置;
    {
        int root=findset(po[i].id);
        ve[root].push_back(i);
    }
    For(i,1,cnt)
    {
        int root=findset(po[i].id);
        if(!vis[root])
        {
            int temp=0,len=ve[root].size();//对root一次操作改变这个集合里面所有元素的答案;
            for(int j=0;j<len;j++)
            {
                int x=ve[root][j];
                temp=max(temp,r[po[x].i]);
                temp=max(temp,l[po[x].j]);
            }
            temp++;ans[root]=temp;
            for(int j=0;j<len;j++)
            {
                int x=ve[root][j];
                l[po[x].j]=r[po[x].i]=temp;
            }
            vis[root]=1;
        }
        ans[po[i].id]=ans[root];
    }
    For(i,1,n)
    {
        For(j,1,m-1)printf("%d ",ans[(i-1)*m+j]);
        printf("%d\n",ans[i*m]);
    }
    return 0;
}

  

posted @ 2016-08-17 21:05  LittlePointer  阅读(343)  评论(0编辑  收藏  举报